#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > gr;
vector<int> st;
vector<int> idn, idm;
vector<bool> u;
int n, m;

void dfs(int v){
    u[v]  = true;
    if (v >= n){
        cout << "1 " << v-n+1 << " " << idm[v-n] << endl;
    } else {
        cout << "0 " << v+1 << " " << idn[v] << endl;
    }
    for (int i = 0; i < (int)gr[v].size(); i++){
        int nxt = gr[v][i];
        st[nxt]--;
        if (st[nxt] == 0){
            dfs(nxt);
        }
    }
}

void solve(){
    u.assign(n+m, false);
    for (int i = 0; i < n; i++){
        if (!u[i] && idn[i] > 0 && st[i] == 0){
            dfs(i);
        }
    }
    for (int j = 0; j < m; j++){
        if (!u[n+j] && idm[j] > 0 && st[n+j] == 0){
            dfs(n+j);
        }
    }
    exit(0);
}

int main(){
    int g;
    cin >> n >> m >> g;

    int ss = 0;
    unordered_map<int, bool> uu;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> a[i][j];
            if (!uu[a[i][j]] && a[i][j]){
                ss++;
            }
            uu[a[i][j]] = true;
        }
    }
    idn.assign(n, 0);
    idm.assign(m, 0);
    gr.resize(n+m);
    st.assign(n+m, 0);
    for (int i = 0; i < n; i++){
        unordered_map<int, bool> used;
        for (int j = 0; j < m; j++){
            if (a[i][j] == 0){
                idn[i] = -1;
                break;
            }
            if (used[a[i][j]]){
                idn[i] = a[i][j];
                break;
            }
            used[a[i][j]] = true;
        }
        if (idn[i] > 0){
            for (int j = 0; j < m; j++){
                if (a[i][j] && a[i][j] != idn[i]){
                    gr[i].push_back(n+j);
                    st[n+j]++;
                }
            }
        }
    }
    for (int j = 0; j < m; j++){
        unordered_map<int, bool> used;
        for (int i = 0; i < n; i++){
            if (a[i][j] == 0){
                idm[j] = -1;
                break;
            }
            if (used[a[i][j]]){
                idm[j] = a[i][j];
                break;
            }
            used[a[i][j]] = true;
        }
        if (idm[j] > 0){
            for (int i = 0; i < n; i++){
                if (a[i][j] && a[i][j] != idm[j]){
                    gr[n+j].push_back(i);
                    st[i]++;
                }
            }
        }
    }
    vector<int> ndi, ndj;
    for (int i = 0; i < n; i++){
        if (idn[i] == 0){
            ndi.push_back(i);
        }
    }
    for (int i = 0; i < m; i++){
        if (idm[i] == 0){
            ndj.push_back(i);
        }
    }
    if (ndj.size() == 0){
        for (int k = 0; k < (int)ndi.size(); k++){
            int i = ndi[k];
            idn[i] = -1;
            for (int j = 0; j < m; j++){
                if (idm[j] != a[i][j]){
                    idn[i] = a[i][j];
                    break;
                }
            }
            if (idn[i] > 0){
                for (int j = 0; j < m; j++){
                    if (a[i][j] != idn[i]){
                        gr[i].push_back(n+j);
                        st[n+j]++;
                    }
                }
            }
        }
    } else
    if (ndi.size() == 0){
        for (int k = 0; k < (int)ndj.size(); k++){
            int j = ndj[k];
            idm[j] = -1;
            for (int i = 0; i < n; i++){
                if (idn[i] != a[i][j]){
                    idm[j] = a[i][j];
                    break;
                }
            }
            if (idm[j] > 0){
                for (int i = 0; i < n; i++){
                    if (a[i][j] != idm[j]){
                        gr[n+j].push_back(i);
                        st[i]++;
                    }
                }
            }
        }
    } else
    if ((int)ndi.size() == 1){
        int i = ndi[0];
        for (int j = 0; j < m; j++){
            if (idm[j] != 0 && idm[j] != a[i][j]){
                idn[i] = a[i][j];
                for (int jj = 0; jj < m; jj++){
                    if (jj != j){
                        gr[i].push_back(jj+n);
                        st[jj+n]++;
                    }
                }
                break;
            }
        }
        if (idn[i]){
            solve();
        }
        idm[ndj[0]] = -1;
        idn[i] = a[i][ndj[0]];
        for (int j = 0; j < m; j++){
            if (j == ndj[0]) continue;
            for (int ii = 0; ii < n; ii++){
                if (ii == i || idn[ii] == -1) continue;
                    gr[j+n].push_back(ii);
                    st[ii]++;
            }
            idm[j] = a[i][j];
            gr[i].push_back(j+n);
            st[j+n]++;
        }
    } else
    if ((int)ndj.size() == 1){
        int j = ndj[0];
        for (int i = 0; i < n; i++){
            if (idn[i] != 0 && idn[i] != a[i][j]){
                idm[j] = a[i][j];
                for (int ii = 0; ii < n; ii++){
                    if (ii != i){
                        gr[j+n].push_back(ii);
                        st[ii]++;
                    }
                }
                break;
            }
        }
        if (idm[j]){
            solve();
        }
        idn[ndi[0]] = -1;
        idm[j] = a[ndi[0]][j];
        for (int i = 0; i < n; i++){
            if (i == ndi[0]) continue;
            for (int jj = 0; jj < m; jj++){
                if (jj == j || idm[jj] == -1) continue;
                    gr[i].push_back(jj+n);
                    st[jj+n]++;
            }
            idn[i] = a[i][j];
            gr[j+n].push_back(i);
            st[i]++;
        }
    }
//    for (int i = 0; i < n; i++){
//        cout << idn[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < m; i++){
//        cout << idm[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < n+m; i++){
//        cout << st[i] << " ";
//    }
//    cout << endl;
    cout << ss << endl;
    solve();
}







